searchNodes=[{"doc":"FunLand defines many different Algebraic Data Types.An Algebraic Data Type is nothing more, than a 'container' for some other data type. Exactly how that 'container' behaves is what makes one ADT different from another.Lists are ADTs. And so are Maps. And Sets. And Tuples. And many other things.Algebraic Data Types contain no value of their own. They get a value, once you fill them with something, and then have useful operations you can perform on their contents.There are many similarities in the way the different ADTs work. This allows us to define behaviours which generalize to all ADTs. Any of your custom data types that you can implement one or multiple of these behaviours for, is an ADT, and will receive the benefits that the implemented ADTs give.Another nice thing about this generalization, is that there is no 'learning a new API' necessary when switching to one thing-that-is-an-ADT to the next.To easily use FunLand in your code, call use FunLand, which will alias for you:Mappable -&gt; A structure is Mappable if there is a way to map a function over it: transforming the contents but keeping the structure.Appliable -&gt; A structure is Applibable if it is Mappable and, given two of them where the first contains a partially-applied function, you can apply them together.Applicative -&gt; A structure is Applicative if it is Appliable and you can create a new one by wrapping any value.Chainable -&gt; A structure is Chainable if it is Appliable and you can chain multiple operations after each other, resulting in just a single structure.Monad -&gt; A structure is a Monad if it is both Applicative and Chainable.Semicombinable -&gt; A structure is Semicombinable if there is a way to combine two structures into one.Combinable -&gt; A structure is Combinable if it is Semicombinable and there is a clearly defined 'empty' element.CombinableMonad -&gt; A structure is a CombinableMonad if it is both Combinable and a Monad.Reducible -&gt; A structure is reducible if you can fold/reduce it to a single value, when giving a Combinable or function+default.Traversable -&gt; A structure is Traversable if it is Reducible and there is a way to flip the ???When given the option operators: true, it will also import the following operators:~&gt; Shorthand for Mappable.map/2&lt;~&gt; Shorthand for Appliable.apply_with/2~&gt;&gt; Shorthand for Chainable.chain/2&lt;&gt; Shorthand for Combinable.combine/2. This operator still works the same for binaries, but will now also work for any other Chainable.","ref":"FunLand.html","title":"FunLand","type":"module"},{"doc":"Infix version of FunLand.Combinable.combine/2.Note that binary strings are Combinable, so &quot;foo&quot; &lt;&gt; &quot;bar&quot; still works.&lt;&gt;/2 can still be used in pattern-matches and guard clauses, but it will fall back to the behavior of Kernel.&lt;&gt;/2, which means that it will only work with binary strings.","ref":"FunLand.html#%3C%3E/2","title":"FunLand.<>/2","type":"macro"},{"doc":"Infix version of FunLand.Appliable.apply_with/2","ref":"FunLand.html#%3C~%3E/2","title":"FunLand.<~>/2","type":"function"},{"doc":"Infix version of FunLand.Mappable.map/2","ref":"FunLand.html#~%3E/2","title":"FunLand.~>/2","type":"function"},{"doc":"Infix version of FunLand.Chainable.chain/2","ref":"FunLand.html#~%3E%3E/2","title":"FunLand.~>>/2","type":"function"},{"doc":"","ref":"FunLand.html#all?/2","title":"FunLand.all?/2","type":"function"},{"doc":"","ref":"FunLand.html#any?/2","title":"FunLand.any?/2","type":"function"},{"doc":"See FunLand.Appliable.apply_with/2.","ref":"FunLand.html#apply_with/2","title":"FunLand.apply_with/2","type":"function"},{"doc":"See FunLand.Chainable.chain/2.","ref":"FunLand.html#chain/2","title":"FunLand.chain/2","type":"function"},{"doc":"See FunLand.Semicombinable.combine/2.","ref":"FunLand.html#combine/2","title":"FunLand.combine/2","type":"function"},{"doc":"See FunLand.Combinable.empty/1.","ref":"FunLand.html#empty/1","title":"FunLand.empty/1","type":"function"},{"doc":"See FunLand.Mappable.map/2.","ref":"FunLand.html#map/2","title":"FunLand.map/2","type":"function"},{"doc":"See FunLand.Applicative.new/2.","ref":"FunLand.html#new/2","title":"FunLand.new/2","type":"function"},{"doc":"See FunLand.Reducible.reduce/2.","ref":"FunLand.html#reduce/2","title":"FunLand.reduce/2","type":"function"},{"doc":"See FunLand.Reducible.reduce/3.","ref":"FunLand.html#reduce/3","title":"FunLand.reduce/3","type":"function"},{"doc":"","ref":"FunLand.html#t:adt/0","title":"FunLand.adt/0","type":"type"},{"doc":"Something is Appliable if you can apply one of it (containing one or multiple functions) with another.Appliable is mostly born out of the needs to apply a function that is already wrapped in a Mappable:If you had a bare function, you could use Mappable.map/2 to apply it over a Mappable.If however, you have a function already inside a Mappable, a new operation has to be defined to apply it over a Mappable (of the same kind).This operation is called apply_with/2.'a function inside a Mappable' is something that happens when you partially apply functions, which isn't that common in Elixir because functions are not automatically curried.Currying and Partial ApplicationAs apply_with works only applies a single argument per function at a time, it works the best when used with curried functions. In Elixir, functions are no curried by default. Fortunately, there exists the Currying library, which transforms your normal functions into curried functions.If you want to be able to use Applicative to its fullest potential, instead of calling fun.(b) in your implementation, use Currying.curry(fun).(b)To be Appliable something also has to be Mappable. To make your data structure Appliable, use use Appliable in its module, and implement both Appliable's apply_with/2 and Mappable's map/2.Fruit Salad ExampleSay we have a bowl with a partiall-made fruit-salad. We have a second bowl, which contains some (peeled) bananas.We would like to add these bananas to the fruit salad.This would be easy if we had our partially-made fruit-salad, as we could just map the 'combine a banana with some fruit salad' operation over the bowl of bananas.However, we don't 'just' have the partially-made fruit-salad, as this would make a big mess of our kitchen countertop. In fact, it is very likely that this bowl-with partially-made fruit salad was the result of combining (mapping) earlier ingredients in bowls.So, we need something similar to map, but instead of taking 'just' an operation, we use a bowl with that operation.For the fruit salad bowl, we could define it as 'take some fruit-salad from Bowl A, combine it with a banana in Bowl B. -&gt; repeat until bananas and fruit-salad are fully combined'.This is called apply_with. Note that, because the part that changes more often is the Appliable with the (partially-applied) function (in other words: The bowl with the partially-made fruit salad), the parameters of this functions are the reverse of Mappable.map.In Other EnvironmentsIn Haskell, Appliable.apply_with is known by the uninformative name ap, often written as &lt;$&gt;.In Category Theory, something that is Appliable is called an Apply.","ref":"FunLand.Appliable.html","title":"FunLand.Appliable","type":"behaviour"},{"doc":"Applies appliable_with_function_inside, which should only contain functions, with as arguments the elements inside appliable_b.For a List, this means that the list(s) that are made by mapping each of the functions inside appliable_with_function_inside over the elements of appliable_b are concatenated, so a single list of all results is returned.iex&gt; [&amp;(&amp;1 + 1), &amp;(&amp;1 - 1)] |&gt; FunLand.Appliable.apply_with([1, 2]) [2, 3, 0, 1] iex&gt; [Currying.curry(&amp;+/2), Currying.curry(&amp;-/2)] |&gt; FunLand.Appliable.apply_with([10, 20]) |&gt; FunLand.Appliable.apply_with([3,4]) [13, 14, 23, 24, 7, 6, 17, 16]For Maybe, whenever one of the two arguments is Nothing, Nothing will be returned. If both are filled, then a result will be computed, and this result will be returned, wrapped in a new Maybe.","ref":"FunLand.Appliable.html#apply_with/2","title":"FunLand.Appliable.apply_with/2","type":"function"},{"doc":"","ref":"FunLand.Appliable.html#c:apply_with/2","title":"FunLand.Appliable.apply_with/2","type":"callback"},{"doc":"See FunLand.Mappable.map/2.","ref":"FunLand.Appliable.html#map/2","title":"FunLand.Appliable.map/2","type":"function"},{"doc":"","ref":"FunLand.Appliable.html#t:appliable/1","title":"FunLand.Appliable.appliable/1","type":"type"},{"doc":"","ref":"FunLand.Applicative.html","title":"FunLand.Applicative","type":"behaviour"},{"doc":"Calls Applicative.apply/2, but afterwards discards the value that was the result of the leftmost argument. (the one evaluated the first).So in the end, the value that went in as right argument (The Algorithmic Data Type containing values) is returned.In Haskell, this is known as *&gt;","ref":"FunLand.Applicative.html#apply_discard_left/2","title":"FunLand.Applicative.apply_discard_left/2","type":"function"},{"doc":"Calls Applicative.apply/2, but afterwards discards the value that was the result of the rightmost argument. (the one evaluated the last).So in the end, the value that went in as left argument (The Algorithmic Data Type containing partially-applied functions) is returned.In Haskell, this is known as &lt;*","ref":"FunLand.Applicative.html#apply_discard_right/2","title":"FunLand.Applicative.apply_discard_right/2","type":"function"},{"doc":"See FunLand.Appliable.apply_with/2.","ref":"FunLand.Applicative.html#apply_with/2","title":"FunLand.Applicative.apply_with/2","type":"function"},{"doc":"See FunLand.Mappable.map/2.","ref":"FunLand.Applicative.html#map/2","title":"FunLand.Applicative.map/2","type":"function"},{"doc":"A structure is Applicative if it is Appliable, as well as having the ability to create a new structure from any value, by newping it.Being able to create new, apply and map means that we can create new structures with some values, transform them and (partially or fully) apply them to each other.Therefore, we're able to re-use all new our old operations in a new, more complex context.Fruit Salad ExampleWe've already seen that a fruit-salad bowl is Mappable and Appliable.However, we'd like to know how we start out: When we have an apple, how do we end up with a bowl filled with an apple?Bowl.new(my_apple) is the implementation that answers this question.Together with apply and map, we can now take arbitrary ingredients, put them in bowls and mix and mash them together to our liking, without soiling the kitchen's countertop:new: We can take an apple, and put it in a bowl: we put the apple in a new bowl to return a bowl with an apple.apply: If we have a bowl with a partially-made fruit-salad, and we have a bowl with an apple, we can take the apple and the partially-made fruit salad to create a bowl with a fruit-with-apples-salad.map: We can take a bowl with any fruit or salad, and do some arbitrary operation with it, such as 'blending'. In this example, we end up with the same bowl, but now filled with blended fruit-salad.In Other EnvironmentsIn Haskell, Applicative.new is known by pure as well as return.In Category Theory, something that is Applicative is know as its more official name Applicative Functor.","ref":"FunLand.Applicative.html#c:new/1","title":"FunLand.Applicative.new/1","type":"callback"},{"doc":"Creates a new Algebraic Data Type that contains value. The first parameter can either be the module name of the Algebraic Data Type that you want to create, or it can be an instance of the same data type, such as [] for List, {} for Tuple, %YourModule{} for YourModule.","ref":"FunLand.Applicative.html#new/2","title":"FunLand.Applicative.new/2","type":"function"},{"doc":"","ref":"FunLand.Applicative.html#t:applicative/1","title":"FunLand.Applicative.applicative/1","type":"type"},{"doc":"Delegation module to be invoked when one of the FunLand behaviour-specifications is called with an Atom as argument.As far as currently known, there is no way to implement one or multiple of the Algebraic Data Type behaviours for an Atom.Therefore, this module is empty.","ref":"FunLand.Builtin.Atom.html","title":"FunLand.Builtin.Atom","type":"module"},{"doc":"","ref":"FunLand.Builtin.BitString.html","title":"FunLand.Builtin.BitString","type":"module"},{"doc":"","ref":"FunLand.Builtin.BitString.html#combine/2","title":"FunLand.Builtin.BitString.combine/2","type":"function"},{"doc":"Callback implementation for FunLand.Combinable.empty/0.","ref":"FunLand.Builtin.BitString.html#empty/0","title":"FunLand.Builtin.BitString.empty/0","type":"function"},{"doc":"Delegation module to be invoked when one of the FunLand behaviour-specifications is called with a Float as argument.As far as currently known, there is no way to implement one or multiple of the Algebraic Data Type behaviours for a Float.Therefore, this module is empty.","ref":"FunLand.Builtin.Float.html","title":"FunLand.Builtin.Float","type":"module"},{"doc":"","ref":"FunLand.Builtin.Function.html","title":"FunLand.Builtin.Function","type":"module"},{"doc":"","ref":"FunLand.Builtin.Function.html#map/2","title":"FunLand.Builtin.Function.map/2","type":"function"},{"doc":"Delegation module to be invoked when one of the FunLand behaviour-specifications is called with an Integer as argument.As far as currently known, there is no way to implement one or multiple of the Algebraic Data Type behaviours for an Integer.Therefore, this module is empty.","ref":"FunLand.Builtin.Integer.html","title":"FunLand.Builtin.Integer","type":"module"},{"doc":"","ref":"FunLand.Builtin.List.html","title":"FunLand.Builtin.List","type":"module"},{"doc":"See FunLand.Applicative.apply_discard_left/2.","ref":"FunLand.Builtin.List.html#apply_discard_left/2","title":"FunLand.Builtin.List.apply_discard_left/2","type":"function"},{"doc":"See FunLand.Applicative.apply_discard_right/2.","ref":"FunLand.Builtin.List.html#apply_discard_right/2","title":"FunLand.Builtin.List.apply_discard_right/2","type":"function"},{"doc":"Callback implementation for FunLand.Appliable.apply_with/2.","ref":"FunLand.Builtin.List.html#apply_with/2","title":"FunLand.Builtin.List.apply_with/2","type":"function"},{"doc":"Callback implementation for FunLand.Chainable.chain/2.","ref":"FunLand.Builtin.List.html#chain/2","title":"FunLand.Builtin.List.chain/2","type":"function"},{"doc":"","ref":"FunLand.Builtin.List.html#combine/2","title":"FunLand.Builtin.List.combine/2","type":"function"},{"doc":"Callback implementation for FunLand.Combinable.empty/0.","ref":"FunLand.Builtin.List.html#empty/0","title":"FunLand.Builtin.List.empty/0","type":"function"},{"doc":"This is called internally whenever a YourMonad.chain() operation fails.For most monads, the default behaviour of crashing is great. For some, you might want to override it.","ref":"FunLand.Builtin.List.html#fail/2","title":"FunLand.Builtin.List.fail/2","type":"function"},{"doc":"","ref":"FunLand.Builtin.List.html#guard/1","title":"FunLand.Builtin.List.guard/1","type":"function"},{"doc":"Free implementation new Mappable.map as FunLand.Builtin.List is Applicative","ref":"FunLand.Builtin.List.html#map/2","title":"FunLand.Builtin.List.map/2","type":"function"},{"doc":"Allows you to write multiple consecutive operations using this monad on new lines. This is called 'monadic do-notation'.For more info, see FunLand.Monad.monadicRules:Every normal line returns a new instance of the monad.You can write x &lt;- some_expr_returning_a_monad_instance to bind x to whatever is inside the monad. You can then use x on any subsequent lines.If you want to use one or multiple normal statements, use let something = some_statement or let something = do ...The final line is of course expected to also return an instance of the monad. Use new at any time to new a value back into a monad if you need.Inside the monadic context, the module of the monad that was defined is automatically imported. Any local calls to e.g. new, apply, chain or functions you've defined yourself in your monad module will thus be called on your module.","ref":"FunLand.Builtin.List.html#monadic/1","title":"FunLand.Builtin.List.monadic/1","type":"macro"},{"doc":"Callback implementation for FunLand.Applicative.new/1.","ref":"FunLand.Builtin.List.html#new/1","title":"FunLand.Builtin.List.new/1","type":"function"},{"doc":"A variant of reduce that accepts anything that is Combinable as second argument. This Combinable will determine what the empty value and the combining operation will be.Pass in the combinable module name to start with empty as accumulator, or the combinable as struct to use that as starting accumulator.This is an automatic function implementation, made possible because FunLand.Builtin.List implements the FunLand.Reducible behaviour.See FunLand.Reducible.reduce/2 for examples.","ref":"FunLand.Builtin.List.html#reduce/2","title":"FunLand.Builtin.List.reduce/2","type":"function"},{"doc":"Callback implementation for FunLand.Reducible.reduce/3.","ref":"FunLand.Builtin.List.html#reduce/3","title":"FunLand.Builtin.List.reduce/3","type":"function"},{"doc":"Converts the reducible into a list, by building up a list from all elements, and in the end reversing it.This is an automatic function implementation, made possible because FunLand.Builtin.List implements the FunLand.Reducible behaviour.","ref":"FunLand.Builtin.List.html#to_list/1","title":"FunLand.Builtin.List.to_list/1","type":"function"},{"doc":"An Example of using traverse:iex&gt; FunLand.Traversable.traverse([1, 2, 3], FunLandic.Maybe, fn x -&gt; FunLandic.Maybe.just(x) end) FunLandic.Maybe.just([1, 2, 3]) iex&gt; FunLand.Traversable.traverse([1, 2, 3], [], fn x -&gt; [x,x] end) [[1, 2, 3], [1, 2, 3], [1, 2, 3], [1, 2, 3], [1, 2, 3], [1, 2, 3], [1, 2, 3], [1, 2, 3]]","ref":"FunLand.Builtin.List.html#traverse/3","title":"FunLand.Builtin.List.traverse/3","type":"function"},{"doc":"Maps are Mappable, because we can map over {k, v}-tuples to create new values. ( Note that different from the Map implementation of Enum.map, the result should be a new value, and not a new {key, value}-tuple. There is no way to alter the key while mapping over a Map, as the key is part of the structure, rather than its contents! )Maps are however not Appliable, (TODO: Explanation)Maps are not Applicative, as there is no way to put 'a value' inside a map (we don't know what key to associate it with) so we cannot define an implementation of new/1.Maps are SemiCombinable, as we can take two key-value groups, and combine them (with duplicates being overridden by the values in the latter). Maps are also Combinable, as it is also possible to create a empty element: an empty map.","ref":"FunLand.Builtin.Map.html","title":"FunLand.Builtin.Map","type":"module"},{"doc":"","ref":"FunLand.Builtin.Map.html#combine/2","title":"FunLand.Builtin.Map.combine/2","type":"function"},{"doc":"Callback implementation for FunLand.Combinable.empty/0.","ref":"FunLand.Builtin.Map.html#empty/0","title":"FunLand.Builtin.Map.empty/0","type":"function"},{"doc":"","ref":"FunLand.Builtin.Map.html#map/2","title":"FunLand.Builtin.Map.map/2","type":"function"},{"doc":"A variant of reduce that accepts anything that is Combinable as second argument. This Combinable will determine what the empty value and the combining operation will be.Pass in the combinable module name to start with empty as accumulator, or the combinable as struct to use that as starting accumulator.This is an automatic function implementation, made possible because FunLand.Builtin.Map implements the FunLand.Reducible behaviour.See FunLand.Reducible.reduce/2 for examples.","ref":"FunLand.Builtin.Map.html#reduce/2","title":"FunLand.Builtin.Map.reduce/2","type":"function"},{"doc":"Callback implementation for FunLand.Reducible.reduce/3.","ref":"FunLand.Builtin.Map.html#reduce/3","title":"FunLand.Builtin.Map.reduce/3","type":"function"},{"doc":"Converts the reducible into a list, by building up a list from all elements, and in the end reversing it.This is an automatic function implementation, made possible because FunLand.Builtin.Map implements the FunLand.Reducible behaviour.","ref":"FunLand.Builtin.Map.html#to_list/1","title":"FunLand.Builtin.Map.to_list/1","type":"function"},{"doc":"","ref":"FunLand.Builtin.MapSet.html","title":"FunLand.Builtin.MapSet","type":"module"},{"doc":"","ref":"FunLand.Builtin.MapSet.html#combine/2","title":"FunLand.Builtin.MapSet.combine/2","type":"function"},{"doc":"Callback implementation for FunLand.Combinable.empty/0.","ref":"FunLand.Builtin.MapSet.html#empty/0","title":"FunLand.Builtin.MapSet.empty/0","type":"function"},{"doc":"A variant of reduce that accepts anything that is Combinable as second argument. This Combinable will determine what the empty value and the combining operation will be.Pass in the combinable module name to start with empty as accumulator, or the combinable as struct to use that as starting accumulator.This is an automatic function implementation, made possible because FunLand.Builtin.MapSet implements the FunLand.Reducible behaviour.See FunLand.Reducible.reduce/2 for examples.","ref":"FunLand.Builtin.MapSet.html#reduce/2","title":"FunLand.Builtin.MapSet.reduce/2","type":"function"},{"doc":"Callback implementation for FunLand.Reducible.reduce/3.","ref":"FunLand.Builtin.MapSet.html#reduce/3","title":"FunLand.Builtin.MapSet.reduce/3","type":"function"},{"doc":"Converts the reducible into a list, by building up a list from all elements, and in the end reversing it.This is an automatic function implementation, made possible because FunLand.Builtin.MapSet implements the FunLand.Reducible behaviour.","ref":"FunLand.Builtin.MapSet.html#to_list/1","title":"FunLand.Builtin.MapSet.to_list/1","type":"function"},{"doc":"Delegation module to be invoked when one of the FunLand behaviour-specifications is called with a PID as argument.As far as currently known, there is no way to implement one or multiple of the Algebraic Data Type behaviours for a PID.Therefore, this module is empty.","ref":"FunLand.Builtin.PID.html","title":"FunLand.Builtin.PID","type":"module"},{"doc":"Delegation module to be invoked when one of the FunLand behaviour-specifications is called with a Port as argument.As far as currently known, there is no way to implement one or multiple of the Algebraic Data Type behaviours for a Port.Therefore, this module is empty.","ref":"FunLand.Builtin.Port.html","title":"FunLand.Builtin.Port","type":"module"},{"doc":"Delegation module to be invoked when one of the FunLand behaviour-specifications is called with a Reference as argument.As far as currently known, there is no way to implement one or multiple of the Algebraic Data Type behaviours for a Reference.Therefore, this module is empty.","ref":"FunLand.Builtin.Reference.html","title":"FunLand.Builtin.Reference","type":"module"},{"doc":"Uses {:ok, value} | :error | {:error, error} as representation of the Either type:Errors are propagated.","ref":"FunLand.Builtin.SuccessTuple.html","title":"FunLand.Builtin.SuccessTuple","type":"module"},{"doc":"See FunLand.Applicative.apply_discard_left/2.","ref":"FunLand.Builtin.SuccessTuple.html#apply_discard_left/2","title":"FunLand.Builtin.SuccessTuple.apply_discard_left/2","type":"function"},{"doc":"See FunLand.Applicative.apply_discard_right/2.","ref":"FunLand.Builtin.SuccessTuple.html#apply_discard_right/2","title":"FunLand.Builtin.SuccessTuple.apply_discard_right/2","type":"function"},{"doc":"Callback implementation for FunLand.Appliable.apply_with/2.","ref":"FunLand.Builtin.SuccessTuple.html#apply_with/2","title":"FunLand.Builtin.SuccessTuple.apply_with/2","type":"function"},{"doc":"Callback implementation for FunLand.Chainable.chain/2.","ref":"FunLand.Builtin.SuccessTuple.html#chain/2","title":"FunLand.Builtin.SuccessTuple.chain/2","type":"function"},{"doc":"Combinable only works if the type inside the success tuples is Combinable.","ref":"FunLand.Builtin.SuccessTuple.html#combine/2","title":"FunLand.Builtin.SuccessTuple.combine/2","type":"function"},{"doc":"Callback implementation for FunLand.Combinable.empty/0.","ref":"FunLand.Builtin.SuccessTuple.html#empty/0","title":"FunLand.Builtin.SuccessTuple.empty/0","type":"function"},{"doc":"","ref":"FunLand.Builtin.SuccessTuple.html#err?/1","title":"FunLand.Builtin.SuccessTuple.err?/1","type":"function"},{"doc":"This is called internally whenever a YourMonad.chain() operation fails.For most monads, the default behaviour of crashing is great. For some, you might want to override it.","ref":"FunLand.Builtin.SuccessTuple.html#fail/2","title":"FunLand.Builtin.SuccessTuple.fail/2","type":"function"},{"doc":"","ref":"FunLand.Builtin.SuccessTuple.html#is_error/1","title":"FunLand.Builtin.SuccessTuple.is_error/1","type":"macro"},{"doc":"","ref":"FunLand.Builtin.SuccessTuple.html#is_ok/1","title":"FunLand.Builtin.SuccessTuple.is_ok/1","type":"macro"},{"doc":"Free implementation new Mappable.map as FunLand.Builtin.SuccessTuple is Applicative","ref":"FunLand.Builtin.SuccessTuple.html#map/2","title":"FunLand.Builtin.SuccessTuple.map/2","type":"function"},{"doc":"Allows you to write multiple consecutive operations using this monad on new lines. This is called 'monadic do-notation'.For more info, see FunLand.Monad.monadicRules:Every normal line returns a new instance of the monad.You can write x &lt;- some_expr_returning_a_monad_instance to bind x to whatever is inside the monad. You can then use x on any subsequent lines.If you want to use one or multiple normal statements, use let something = some_statement or let something = do ...The final line is of course expected to also return an instance of the monad. Use new at any time to new a value back into a monad if you need.Inside the monadic context, the module of the monad that was defined is automatically imported. Any local calls to e.g. new, apply, chain or functions you've defined yourself in your monad module will thus be called on your module.","ref":"FunLand.Builtin.SuccessTuple.html#monadic/1","title":"FunLand.Builtin.SuccessTuple.monadic/1","type":"macro"},{"doc":"Callback implementation for FunLand.Applicative.new/1.","ref":"FunLand.Builtin.SuccessTuple.html#new/1","title":"FunLand.Builtin.SuccessTuple.new/1","type":"function"},{"doc":"","ref":"FunLand.Builtin.SuccessTuple.html#ok?/1","title":"FunLand.Builtin.SuccessTuple.ok?/1","type":"function"},{"doc":"A variant of reduce that accepts anything that is Combinable as second argument. This Combinable will determine what the empty value and the combining operation will be.Pass in the combinable module name to start with empty as accumulator, or the combinable as struct to use that as starting accumulator.This is an automatic function implementation, made possible because FunLand.Builtin.SuccessTuple implements the FunLand.Reducible behaviour.See FunLand.Reducible.reduce/2 for examples.","ref":"FunLand.Builtin.SuccessTuple.html#reduce/2","title":"FunLand.Builtin.SuccessTuple.reduce/2","type":"function"},{"doc":"Callback implementation for FunLand.Reducible.reduce/3.","ref":"FunLand.Builtin.SuccessTuple.html#reduce/3","title":"FunLand.Builtin.SuccessTuple.reduce/3","type":"function"},{"doc":"Converts the reducible into a list, by building up a list from all elements, and in the end reversing it.This is an automatic function implementation, made possible because FunLand.Builtin.SuccessTuple implements the FunLand.Reducible behaviour.","ref":"FunLand.Builtin.SuccessTuple.html#to_list/1","title":"FunLand.Builtin.SuccessTuple.to_list/1","type":"function"},{"doc":"","ref":"FunLand.Builtin.Tuple.html","title":"FunLand.Builtin.Tuple","type":"module"},{"doc":"","ref":"FunLand.Builtin.Tuple.html#map/2","title":"FunLand.Builtin.Tuple.map/2","type":"function"},{"doc":"Defines a 'chain' operation to apply a function that takes a simple value and outputs a new Chainable to a value inside a Chainable.Something that is Chainable also needs to be Appliable.Fruit Salad ExampleThere is one problem we haven't covered yet: What if you have an operation that itself returns a bowl?Say we have a 'blend' operation, that takes an apple, and returns a bowl with apple juice.If we would just map 'blend' over a bowl of apples, we would end up putting all the bowls of apple juice inside our original bowl.This is clearly not what we want. Instead, we want to combine the results together back into a single bowl.The implementation that tells how to do this, is called chain. For bowls, it would be 'put/pour contents of resulting bowl back into original bowl and forget about the other bowl.'In Other Environmentsin Haskell, chain is known by the name bind, or &gt;&gt;=.","ref":"FunLand.Chainable.html","title":"FunLand.Chainable","type":"behaviour"},{"doc":"See FunLand.Appliable.apply_with/2.","ref":"FunLand.Chainable.html#apply_with/2","title":"FunLand.Chainable.apply_with/2","type":"function"},{"doc":"Chains a function that returns a Chainable at the end of some calculation that returns a Chainable.So to chain means: Taking the result of an operation that returns a container outside of its container, and passing it in to the next function, finally returning the resulting container.","ref":"FunLand.Chainable.html#chain/2","title":"FunLand.Chainable.chain/2","type":"function"},{"doc":"","ref":"FunLand.Chainable.html#c:chain/2","title":"FunLand.Chainable.chain/2","type":"callback"},{"doc":"See FunLand.Mappable.map/2.","ref":"FunLand.Chainable.html#map/2","title":"FunLand.Chainable.map/2","type":"function"},{"doc":"See FunLand.Applicative.new/2.","ref":"FunLand.Chainable.html#new/2","title":"FunLand.Chainable.new/2","type":"function"},{"doc":"","ref":"FunLand.Chainable.html#t:chainable/1","title":"FunLand.Chainable.chainable/1","type":"type"},{"doc":"If an operation is can combine two elements, and there is a clearly defined empty empty version that can be used to keep the same element when used on an element.In Category Theory, something that is Combinable is called a Monoid.By doing use FunLand.Combinable you get an implementation of the Collectable protocol for free. If you want to implement your own version of Collectable, add Combinable with use FunLand.Combinable, auto_collectable: false.ExamplesInteger-addition with 0 as empty element forms a Monoid, also known as the Sum.Integer-multiplication with 1 as empty element forms a Monoid, also known as the Product.List concatenation with [] as empty element.String concatenation with the empty string &quot;&quot; as empty element.Set union with the empty set as empty element.Fruit Salad ExampleBowls that you can use to mix fruits in, are a monoid:The combine operation would be to put the fruits from Bowl A into Bowl B, keeping that one. The empty operation would be to take an emtpy bowl.As can be seen, this follows the Combinable laws:left-identity: putting the contents of an empty bowl into a bowl with apples, would be the same as doing nothing (you still have 'a bowl with apples')right-identity: putting the contents a bowl filled with apples into an empty bowl, would be the same as doing nothing (you still have 'a bowl with apples')","ref":"FunLand.Combinable.html","title":"FunLand.Combinable","type":"behaviour"},{"doc":"See FunLand.Semicombinable.combine/2.","ref":"FunLand.Combinable.html#combine/2","title":"FunLand.Combinable.combine/2","type":"function"},{"doc":"","ref":"FunLand.Combinable.html#c:empty/0","title":"FunLand.Combinable.empty/0","type":"callback"},{"doc":"","ref":"FunLand.Combinable.html#empty/1","title":"FunLand.Combinable.empty/1","type":"function"},{"doc":"","ref":"FunLand.Combinable.html#t:combinable/1","title":"FunLand.Combinable.combinable/1","type":"type"},{"doc":"Things that are both combinable and a monad.Useful to build Parser Combinators.Known in Haskell as MonadPlus.","ref":"FunLand.CombinableMonad.html","title":"FunLand.CombinableMonad","type":"module"},{"doc":"See FunLand.Appliable.apply_with/2.","ref":"FunLand.CombinableMonad.html#apply_with/2","title":"FunLand.CombinableMonad.apply_with/2","type":"function"},{"doc":"See FunLand.Chainable.chain/2.","ref":"FunLand.CombinableMonad.html#chain/2","title":"FunLand.CombinableMonad.chain/2","type":"function"},{"doc":"See FunLand.Semicombinable.combine/2.","ref":"FunLand.CombinableMonad.html#combine/2","title":"FunLand.CombinableMonad.combine/2","type":"function"},{"doc":"See FunLand.Combinable.empty/1.","ref":"FunLand.CombinableMonad.html#empty/1","title":"FunLand.CombinableMonad.empty/1","type":"function"},{"doc":"See FunLand.Mappable.map/2.","ref":"FunLand.CombinableMonad.html#map/2","title":"FunLand.CombinableMonad.map/2","type":"function"},{"doc":"See FunLand.Applicative.new/2.","ref":"FunLand.CombinableMonad.html#new/2","title":"FunLand.CombinableMonad.new/2","type":"function"},{"doc":"FunLand Helper functions for some common Algorithmic Data Type implementations.","ref":"FunLand.Helper.html","title":"FunLand.Helper","type":"module"},{"doc":"The constant function: Returns the first argument, regardless of the second argument.","ref":"FunLand.Helper.html#const/2","title":"FunLand.Helper.const/2","type":"function"},{"doc":"The constant function, reversed: Returns the second argument, regardless of the first argument.","ref":"FunLand.Helper.html#const_reverse/2","title":"FunLand.Helper.const_reverse/2","type":"function"},{"doc":"The identity function: Returns what was passed in, unchanged.","ref":"FunLand.Helper.html#id/1","title":"FunLand.Helper.id/1","type":"function"},{"doc":"Returns the proper module to dispatch FunLand functions to, given a:Builtin data type (dispatches to FunLand.Builtin.DataTypeModuleName).Struct (dispatches to the struct name module).module name (returns this module name).","ref":"FunLand.Helper.html#map_datatype_to_module/1","title":"FunLand.Helper.map_datatype_to_module/1","type":"function"},{"doc":"","ref":"FunLand.Helper.GuardMacros.html","title":"FunLand.Helper.GuardMacros","type":"module"},{"doc":"Something is Mappable if there is a way to map a function over it.mapping means to apply a transformation to the contents, without changing the structure.This module both contains the Mappable behaviour, which might be added to your modules/structures by using use Mappable from within them, as well as the Mappable.map(mappable, fun) function, which will dispatch to whatever structure is passed in as first argument.In Category Theory, something that is Mappable is called a Functor.Fruit Salad ExampleSay we have an apple. There are many operations we could do with an apple, such as peel it, slice it, juice it, etc.However, right now we don't have an apple, but a bowl filled with apples. How can we make sure we can still use all the operations we could on single apples?The answer: We need to take the apples one-by-one from the bowl, perform the desired operation, and then put them back in the bowl.This 'take -&gt; perform -&gt; put back' is the implementation of map for a bowl. It works similar for other data structures:Exactly how to take something and put a result back, and when to perform the desired operation (if we have an empty bowl, for instance, there's nothing to do) is what you need to define in your implementation.","ref":"FunLand.Mappable.html","title":"FunLand.Mappable","type":"behaviour"},{"doc":"Maps the function function over all things inside mappable.Exactly what this means, depends on the structure of mappable.For lists, for instance, this means that all of the elements will be transformed by function. For Maybe, this will do nothing if Maybe is Nothing, while it will transform whatever is inside if the Maybe is Just something.","ref":"FunLand.Mappable.html#map/2","title":"FunLand.Mappable.map/2","type":"function"},{"doc":"","ref":"FunLand.Mappable.html#c:map/2","title":"FunLand.Mappable.map/2","type":"callback"},{"doc":"","ref":"FunLand.Mappable.html#t:mappable/1","title":"FunLand.Mappable.mappable/1","type":"type"},{"doc":"A Monad: a sequence of operations inside a context.Monads are hard to explain, because they are very powerful but extremely general at the same time.Simply put: To be a Monad, something has to be Applicative, as well as Chainable (and therefore also be Appliable and Mappable). Therefore, a monad is very versatile, as it allows us to perform all these four operations:new, which allows us to put anything inside a new structure of this kind.map, which allows us to take a normal function transforming one element, and change it into a function that transforms all of the contents of the structure.chain, which allows us to take a function that usually returns a new structure of this kind, and instead apply it on an already-existing structure, the result being a single new structure instead of multiple layers of it.apply_with, which allows us to take a partially-applied function inside a structure of this kind to be applied with another structure of this kind.This allows us to:Take any normal value and put it into our new structure.Use any normal functions as well as any functions returning a structure of this kind to be used in a sequence of operations.determine what should happen between subsequent operations. (when/how/if the next step should be executed)","ref":"FunLand.Monad.html","title":"FunLand.Monad","type":"module"},{"doc":"See FunLand.Appliable.apply_with/2.","ref":"FunLand.Monad.html#apply_with/2","title":"FunLand.Monad.apply_with/2","type":"function"},{"doc":"See FunLand.Chainable.chain/2.","ref":"FunLand.Monad.html#chain/2","title":"FunLand.Monad.chain/2","type":"function"},{"doc":"See FunLand.Mappable.map/2.","ref":"FunLand.Monad.html#map/2","title":"FunLand.Monad.map/2","type":"function"},{"doc":"Allows you to write multiple consecutive operations using this monad on new lines. This is called 'monadic do-notation'.Rules:Every normal line returns a new instance of the monad.You can write x &lt;- some_expr_returning_a_monad_instance to bind x to whatever is inside the monad. You can then use x on any subsequent lines.If you want to use one or multiple statements, use let something = some_statement or let something = do ...The final line is of course expected to also return an instance of the monad. Use new at any time to new a value back into a monad if you need.Inside the monadic context, the module of the monad that was defined is automatically imported. Any local calls to e.g. new, apply, chain or functions you've defined yourself in your monad module will thus be called on your module.Examplesiex&gt; require FunLand.Monad iex&gt; FunLand.Monad.monadic({:ok, nil}) do iex&gt; x &lt;- {:ok, 10} iex&gt; y &lt;- {:ok, 20} iex&gt; new(x * y) iex&gt; end {:ok, 200} iex&gt; require FunLand.Monad iex&gt; FunLand.Monad.monadic({:ok, nil}) do iex&gt; x &lt;- {:ok, 10} iex&gt; y &lt;- {:error, :something_went_wrong} iex&gt; new(x * y) iex&gt; end {:error, :something_went_wrong}","ref":"FunLand.Monad.html#monadic/2","title":"FunLand.Monad.monadic/2","type":"macro"},{"doc":"See FunLand.Applicative.new/2.","ref":"FunLand.Monad.html#new/2","title":"FunLand.Monad.new/2","type":"function"},{"doc":"Anything that implements the Reducible behaviour, can be reduced to a single value, when given a combinable (or combining-function + base value).This is enough information to convert any reducible to a List. It even is enough information to implement most enumerable methods.However, what is not possible, is to stop halfway through the reduction. Therefore, Reducible is a lot simpler than the Enumerable protocol.For convenience, though, a very basic implementation of the Enumerable protocol is automatically added when you use Reducible. This implementation first converts your Reducible to a list, and then enumerates on that.This is very convenient, but it does mean that your whole reducible is first converted to a list. This will therefore always be slower than a full-blown custom implementation that is specific for your structure.If you want to implement your own version of Enumerable, add Reducible with use FunLand.Reducible, auto_enumerable: false.","ref":"FunLand.Reducible.html","title":"FunLand.Reducible","type":"behaviour"},{"doc":"A variant of reduce that accepts anything that is Combinable as second argument. This Combinable will determine what the empty value and the combining operation will be.Pass in the combinable module name to start with empty as accumulator, or the combinable as struct to use that as starting accumulator.This is an automatic function implementation, made possible because FunLand.Reducible implements the FunLand.Reducible behaviour.Some examples:iex&gt; [&quot;the&quot;, &quot;quick&quot;, &quot;brown&quot;, &quot;fox&quot;] |&gt; FunLand.Reducible.reduce(&quot;&quot;) &quot;thequickbrownfox&quot;Or given the following module:defmodule Score do defstruct [val: 0] use FunLand.Combinable def new(val), do: %Score{val: val} def empty(), do: new(0) def combine(%Score{val: a}, %Score{val: b}), do: new(a + b) end iex&gt; [Score.new(10), Score.new(20), Score.new(42)] |&gt; FunLand.Reducible.reduce(Score) %Score{val: 72}","ref":"FunLand.Reducible.html#reduce/2","title":"FunLand.Reducible.reduce/2","type":"function"},{"doc":"","ref":"FunLand.Reducible.html#reduce/3","title":"FunLand.Reducible.reduce/3","type":"function"},{"doc":"","ref":"FunLand.Reducible.html#c:reduce/3","title":"FunLand.Reducible.reduce/3","type":"callback"},{"doc":"","ref":"FunLand.Reducible.html#t:reducible/1","title":"FunLand.Reducible.reducible/1","type":"type"},{"doc":"An operation is Semiombinable if you can combine two values using it, but there is no clearly defined neutral thing which you can combine with an element to obtain itself.if there is a clearly definable neutral element, use FunLand.Combinable instead.Fruit Salad ExampleIf you have one bowl with apples, and a second bowl with oranges, one can combine these, by putting the apples and the oranges in the same bowl.This follows the Semicombinable law:associativity: combine(combine(bowl_with_apples, bowl_with_oranges), bowl_with_bananas) results in the same bowl as combine(bowl_with_apples, combine(bowl_with_oranges, bowl_with_bananas)) ## Some Common Semigroups - Strings (binaries) - List Concatenation - Algebraic Addition - Algebraic Multiplication Many semicombinables are not only 'semi', but fully Combinable. (See theCombinable` module) ## In Other Environments - In Category Theory, something that is Semicombinable is called a Semigroup.","ref":"FunLand.Semicombinable.html","title":"FunLand.Semicombinable","type":"behaviour"},{"doc":"","ref":"FunLand.Semicombinable.html#combine/2","title":"FunLand.Semicombinable.combine/2","type":"function"},{"doc":"","ref":"FunLand.Semicombinable.html#c:semicombine/2","title":"FunLand.Semicombinable.semicombine/2","type":"callback"},{"doc":"","ref":"FunLand.Semicombinable.html#t:semicombinable/1","title":"FunLand.Semicombinable.semicombinable/1","type":"type"},{"doc":"WARNING: This module is not completely stable yet, and should therefore not be used in practice yet.","ref":"FunLand.Traversable.html","title":"FunLand.Traversable","type":"behaviour"},{"doc":"The Module argument is there to know what kind of Applicative structure to return in the case the traversable that is passed is empty (meaning that fun is never called). As many definitions of traverse are recursive, this case frequently occurs.Thus: result_module should be the same name as the name of thing you return from fun.","ref":"FunLand.Traversable.html#traverse/3","title":"FunLand.Traversable.traverse/3","type":"function"},{"doc":"","ref":"FunLand.Traversable.html#c:traverse/3","title":"FunLand.Traversable.traverse/3","type":"callback"},{"doc":"","ref":"FunLand.Traversable.html#t:traversable/1","title":"FunLand.Traversable.traversable/1","type":"type"}]